#include <iostream>
using namespace std;

class Firma
{
	char *denumire;
	const int nrInreg;
	int nrAngajati;
	char** departamente;
	int nrDepart;
	char tip;
	static int nrSRL;
	static int nrPFA;

public:
	
	Firma():nrInreg(0)
	{
		denumire = new char[strlen("firma")+1];
		strcpy(denumire, "firma");
		nrAngajati = 0;
		nrDepart = 1;
		departamente = new char*[nrDepart];
		departamente[0] = new char[strlen("IT")+1];
		strcpy(departamente[0], "IT");
		tip = 'P';
		nrPFA++;
	}

	Firma(char *d, int nr, int nra, int nrdep, char **dep, char t):nrInreg(nr)
	{
		denumire = new char[strlen(d)+1];
		strcpy(denumire, d);
		nrAngajati = nra;
		nrDepart = nrdep;
		departamente = new char*[nrDepart];
		for(int i=0;i<nrDepart;i++)
		{
			departamente[i] = new char[strlen(dep[i])+1];
			strcpy(departamente[i], dep[i]);
		}
		tip = t;
		if (tip=='S') nrSRL++;
		else nrPFA++;
	}

	~Firma()
	{
		delete[] denumire;
		for(int i=0;i<nrDepart;i++)
			delete[] departamente[i];
		delete[] departamente;
		if (tip=='S') nrSRL--;
		else nrPFA--;
	}

	Firma(Firma &f):nrInreg(f.nrInreg)
	{
		denumire = new char[strlen(f.denumire)+1];
		strcpy(denumire, f.denumire);
		nrAngajati = f.nrAngajati;
		nrDepart = f.nrDepart;
		departamente = new char*[f.nrDepart];
		for(int i=0;i<nrDepart;i++)
		{
			departamente[i] = new char[strlen(f.departamente[i])+1];
			strcpy(departamente[i], f.departamente[i]);
		}
		tip = f.tip;
		if (tip=='S') nrSRL++;
		else nrPFA++;
	}

	Firma operator=(Firma f)
	{
		delete [] this->denumire;
		this->denumire = new char[strlen(f.denumire)+1];
		strcpy(this->denumire, f.denumire);
		this->nrAngajati = f.nrAngajati;
		for(int i=0;i<this->nrDepart;i++)
			delete[] this->departamente[i];
		delete[] this->departamente;
		this->nrDepart = f.nrDepart;
		this->departamente = new char*[f.nrDepart];
		for(int i=0;i<this->nrDepart;i++)
		{
			this->departamente[i] = new char[strlen(f.departamente[i])+1];
			strcpy(this->departamente[i], f.departamente[i]);
		}
		if (tip=='S') nrSRL--;
		else nrPFA--;
		tip = f.tip;
		if (tip=='S') nrSRL++;
		else nrPFA++;
		return *this;
	}

	void afisare()
	{
		cout<<"Firma "<<denumire<<" cu nr inreg "<<nrInreg<<
			" are "<<nrAngajati<<" angajati "<<" tipul "<<tip<<" si "<<nrDepart<<" departamente"<<endl;
		for(int i=0;i<nrDepart;i++)
			cout<<departamente[i]<<" ";
		cout<<endl;
	}

	static int getNrSRL()
	{
		return nrSRL;
	}

	static int getNrPFA()
	{
		return nrPFA;
	}

	Firma(bool vb):nrInreg(123)
	{
		if(vb==true)
		{
			cout<<"Denumire: "<<endl;
			char buffer[20];
			cin>>buffer;
			denumire = new char[strlen(buffer)+1];
			strcpy(denumire, buffer);
			cout<<"Nr angajati: "<<endl;
			cin>>nrAngajati;
			cout<<"Nr depart: "<<endl;
			cin>>nrDepart;
			cout<<"Vector depart: "<<endl;
			departamente = new char*[nrDepart];
			for(int i=0;i<nrDepart;i++)
			{
				cin>>buffer;
				departamente[i] = new char[strlen(buffer)+1];
				strcpy(departamente[i], buffer);
			}
			cout<<"Tip: "<<endl;
			cin>>tip;
			if(tip=='S')
				nrSRL++;
			else nrPFA++;
		}
	}
};

int Firma::nrSRL = 0;
int Firma::nrPFA = 0;

void main()
{
	Firma f1;
	
	char* dep[3] = {"IT", "HR", "PR"};

	Firma f2("Microsoft", 123, 500, 3, dep, 'S');
	
	Firma f3 = f2;

	f1.afisare();
	f2.afisare();
	f3.afisare();

	cout<<"Nr SRL-uri "<<Firma::getNrSRL()<<endl;
	cout<<"Nr PFA-uri "<<Firma::getNrPFA()<<endl;

	f1 = f3;
	f1.afisare();

	cout<<"Nr SRL-uri "<<Firma::getNrSRL()<<endl;
	cout<<"Nr PFA-uri "<<Firma::getNrPFA()<<endl;

	//Firma f4(true);
	//f4.afisare();
}