#include <iostream>
#include <fstream>
using namespace std;

class Profesor
{
	char *nume;
	int varsta;
	const int marca;
	float salariu;
	int nrDiscipline;
	char **discipline;
	int nrEvaluari;
	float *calificative;

public:
	Profesor():marca(0)
	{
		nume = new char[strlen("Anonim")+1];
		strcpy(nume, "Anonim");
		varsta = 0;
		salariu = 0.0f;
		nrDiscipline = 1;
		discipline = new char*[nrDiscipline];
		discipline[0] = new char[strlen("POO")+1];
		strcpy(discipline[0], "POO");
		nrEvaluari = 1;
		calificative = new float[nrEvaluari];
		calificative[0] = 0.0f;
	}

	Profesor(char *n, int v, int m, float s, int nrd, char **discip, int nre, float *calif):marca(m)
	{
		nume = new char[strlen(n)+1];
		strcpy(nume, n);
		varsta = v;
		salariu = s;
		nrDiscipline = nrd;
		discipline = new char*[nrDiscipline];
		for(int i=0;i<nrDiscipline;i++)
		{
			discipline[i] = new char[strlen(discip[i])+1];
			strcpy(discipline[i], discip[i]);
		}
		nrEvaluari = nre;
		calificative = new float[nrEvaluari];
		for(int i=0;i<nrEvaluari;i++)
			calificative[i] = calif[i];
	}

	~Profesor()
	{
		delete[] nume;
		for(int i=0;i<nrDiscipline;i++)
			delete[] discipline[i];
		delete[] discipline;
		delete[] calificative;
	}

	void afisare();
	/*{
		cout<<"Profesorul "<<nume<<" are varsta "<<varsta<<" marca "<<marca<<
			" salariul "<<salariu<<" preda la "<<nrDiscipline<<" discipline "<<" si a avut "<<nrEvaluari<<" evaluari"<<endl;
		cout<<"Lista de discipline: "<<endl;
		for(int i=0;i<nrDiscipline;i++)
			cout<<discipline[i]<<" ";
		cout<<endl;
		cout<<"Lista punctajelor obtinute la evaluare: "<<endl;
		for(int i=0;i<nrEvaluari;i++)
			cout<<calificative[i]<<" ";
		cout<<endl;
	}*/

	friend ostream& operator<<(ostream& iesire, Profesor& p);
	friend ofstream& operator<<(ofstream& iesire, Profesor& p);
	/*friend ostream& operator<<(ostream& iesire, Profesor& p)
	{
		iesire<<"Profesorul "<<p.nume<<" are varsta "<<p.varsta<<" marca "<<p.marca<<
			" salariul "<<p.salariu<<" preda la "<<p.nrDiscipline<<" discipline "<<" si a avut "<<p.nrEvaluari<<" evaluari"<<endl;
		iesire<<"Lista de discipline: "<<endl;
		for(int i=0;i<p.nrDiscipline;i++)
			iesire<<p.discipline[i]<<" ";
		iesire<<endl;
		iesire<<"Lista punctajelor obtinute la evaluare: "<<endl;
		for(int i=0;i<p.nrEvaluari;i++)
			iesire<<p.calificative[i]<<" ";
		iesire<<endl;
		return iesire;
	}*/

	friend istream& operator>>(istream& intrare, Profesor &p);
	friend ifstream& operator>>(ifstream& intrare, Profesor &p);

	Profesor(Profesor &p):marca(p.marca)
	{
		nume = new char[strlen(p.nume)+1];
		strcpy(nume, p.nume);
		varsta = p.varsta;
		salariu = p.salariu;
		nrDiscipline = p.nrDiscipline;
		discipline = new char*[nrDiscipline];
		for(int i=0;i<nrDiscipline;i++)
		{
			discipline[i] = new char[strlen(p.discipline[i])+1];
			strcpy(discipline[i], p.discipline[i]);
		}
		nrEvaluari = p.nrEvaluari;
		calificative = new float[nrEvaluari];
		for(int i=0;i<nrEvaluari;i++)
			calificative[i] = p.calificative[i];
	}

	Profesor operator+(Profesor p)
	{
		Profesor temp = *this;
		char **aux = new char*[temp.nrDiscipline + p.nrDiscipline];
		for(int i=0;i<temp.nrDiscipline;i++)
		{
			aux[i] = new char[strlen(temp.discipline[i])+1];
			strcpy(aux[i], temp.discipline[i]);
		}
		for(int j=0;j<p.nrDiscipline;j++)
		{
			aux[temp.nrDiscipline+j] = new char[strlen(p.discipline[j])+1];
			strcpy(aux[temp.nrDiscipline+j], p.discipline[j]);
		}

		for(int i=0;i<temp.nrDiscipline;i++)
			delete[] temp.discipline[i];
		delete[] temp.discipline;

		temp.nrDiscipline += p.nrDiscipline;
		temp.discipline = new char*[temp.nrDiscipline];
		for(int i=0;i<temp.nrDiscipline;i++)
		{
			temp.discipline[i] = new char[strlen(aux[i])+1];
			strcpy(temp.discipline[i], aux[i]);
		}

		for(int i=0;i<temp.nrDiscipline;i++)
			delete[] aux[i];
		delete[] aux;

		return temp;
	}

	Profesor operator+(char *d)
	{
		Profesor temp = *this;
		char **aux = new char*[temp.nrDiscipline +1];
		for(int i=0;i<temp.nrDiscipline;i++)
		{
			aux[i] = new char[strlen(temp.discipline[i])+1];
			strcpy(aux[i], temp.discipline[i]);
		}
		
		aux[temp.nrDiscipline] = new char[strlen(d)+1];
		strcpy(aux[temp.nrDiscipline], d);
		

		for(int i=0;i<temp.nrDiscipline;i++)
			delete[] temp.discipline[i];
		delete[] temp.discipline;

		temp.nrDiscipline += 1;
		temp.discipline = new char*[temp.nrDiscipline];
		for(int i=0;i<temp.nrDiscipline;i++)
		{
			temp.discipline[i] = new char[strlen(aux[i])+1];
			strcpy(temp.discipline[i], aux[i]);
		}

		for(int i=0;i<temp.nrDiscipline;i++)
			delete[] aux[i];
		delete[] aux;

		return temp;
	}

	friend Profesor operator+(char *d, Profesor &p)
	{
		char **aux = new char*[p.nrDiscipline +1];
		for(int i=0;i<p.nrDiscipline;i++)
		{
			aux[i] = new char[strlen(p.discipline[i])+1];
			strcpy(aux[i], p.discipline[i]);
		}
		
		aux[p.nrDiscipline] = new char[strlen(d)+1];
		strcpy(aux[p.nrDiscipline], d);
		
		for(int i=0;i<p.nrDiscipline;i++)
			delete[] p.discipline[i];
		delete[] p.discipline;

		p.nrDiscipline += 1;
		p.discipline = new char*[p.nrDiscipline];
		for(int i=0;i<p.nrDiscipline;i++)
		{
			p.discipline[i] = new char[strlen(aux[i])+1];
			strcpy(p.discipline[i], aux[i]);
		}

		for(int i=0;i<p.nrDiscipline;i++)
			delete[] aux[i];
		delete[] aux;

		return p;
	}
};

ostream& operator<<(ostream& iesire, Profesor& p)
	{
		iesire<<"Profesorul "<<p.nume<<" are varsta "<<p.varsta<<" marca "<<p.marca<<
			" salariul "<<p.salariu<<" preda la "<<p.nrDiscipline<<" discipline "<<" si a avut "<<p.nrEvaluari<<" evaluari"<<endl;
		iesire<<"Lista de discipline: "<<endl;
		for(int i=0;i<p.nrDiscipline;i++)
			iesire<<p.discipline[i]<<" ";
		iesire<<endl;
		iesire<<"Lista punctajelor obtinute la evaluare: "<<endl;
		for(int i=0;i<p.nrEvaluari;i++)
			iesire<<p.calificative[i]<<" ";
		iesire<<endl;
		return iesire;
	}

ofstream& operator<<(ofstream& iesire, Profesor& p)
	{
		iesire<<"Profesorul "<<p.nume<<" are varsta "<<p.varsta<<" marca "<<p.marca<<
			" salariul "<<p.salariu<<" preda la "<<p.nrDiscipline<<" discipline "<<" si a avut "<<p.nrEvaluari<<" evaluari"<<endl;
		iesire<<"Lista de discipline: "<<endl;
		for(int i=0;i<p.nrDiscipline;i++)
			iesire<<p.discipline[i]<<" ";
		iesire<<endl;
		iesire<<"Lista punctajelor obtinute la evaluare: "<<endl;
		for(int i=0;i<p.nrEvaluari;i++)
			iesire<<p.calificative[i]<<" ";
		iesire<<endl;
		return iesire;
	}

void Profesor::afisare()
	{
		cout<<"Profesorul "<<nume<<" are varsta "<<varsta<<" marca "<<marca<<
			" salariul "<<salariu<<" preda la "<<nrDiscipline<<" discipline "<<" si a avut "<<nrEvaluari<<" evaluari"<<endl;
		cout<<"Lista de discipline: "<<endl;
		for(int i=0;i<nrDiscipline;i++)
			cout<<discipline[i]<<" ";
		cout<<endl;
		cout<<"Lista punctajelor obtinute la evaluare: "<<endl;
		for(int i=0;i<nrEvaluari;i++)
			cout<<calificative[i]<<" ";
		cout<<endl;
	}

void main()
{
	Profesor p1;
	char *discip[3] = {"PAW","SDD","POO"};
	float eval[3] = {4.5f, 3.9f, 5.0f};
	Profesor p2("Gigel",35,1234,2000,3,discip,3,eval);

	p1.afisare();
	p2.afisare();

	cout<<p1<<p2;

	ofstream fisier("fisier.txt", ios_base::out);
	fisier<<p1<<p2;
	fisier.close();

	cout<<p2+p1;
	(p1+p2).afisare();

	cout<<p1+"Java";

	cout<<"Java" + p2;
}